-- cntdec, version simplifie
-- cntdec_s.vhd

package decimalsimple is
   type chiffre is range 0 to 9 ;
   type nombre is array (integer range <>) of chiffre ;
end decimalsimple ;


use work.decimalsimple.all; -- dfinit chiffre et nombre

entity cntdec_s is
   generic ( taille : integer := 2 ) ; 
   -- permet de fixer le nombre de decades, 2 par defaut
   port ( clk, en, zero : in bit ;
      sortie : out nombre (taille-1 downto 0) ;
      carry  : out bit) ;
end cntdec_s ;

architecture multibloc of cntdec_s is
   signal retenue : bit_vector (taille downto 0) ;
begin
retenue(0) <= en ;
carry <= retenue(taille) ;
ci : for i in 0 to taille - 1 generate
      signal countTemp : chiffre ;
begin
   sortie(i)  <= countTemp ;
   retenue(i+1) <= retenue(i) when countTemp = 9 else '0' ;
   incre : process
   begin
      wait until clk = '1' ;
      if zero = '1' then
         countTemp <= 0 ;
      elsif retenue(i) = '1' then
         countTemp <= (countTemp + 1) mod 10 ;  
      end if ;
   end process incre ;
end generate ci ;
end multibloc ;



