-- description d'une decade d'un compteur decimal synchrone.
-- decade.vhd

USE work.decimal.all;

ENTITY decade IS 
   PORT (clk, en, raz : in bit ;
         count: OUT chiffre ;
         dix  : OUT bit) ;
END decade ;

ARCHITECTURE surcharge OF decade IS
   signal countTemp: chiffre ;
begin
   count <= countTemp ;
   dix <= en when countTemp = 9 else '0' ;
   incre : PROCESS
      BEGIN
      WAIT UNTIL (clk = '1') ;
         if (raz = '1') then
            countTemp <= 0 ;
         elsif (en = '1') then
            countTemp <= countTemp + 1 ; -- surcharge 
         end if ;
      END process incre ;
END surcharge ; 

library ieee ;
use ieee.numeric_bit.all ;

ARCHITECTURE vecteur OF decade IS
   signal countTemp: unsigned(3 downto 0) ;
begin
   count <= chiffre(to_integer(countTemp)) ;
   dix <= en when countTemp = 9 else '0' ;
   incre : PROCESS
      BEGIN
      WAIT UNTIL rising_edge(clk) ;
         if raz = '1' then
            countTemp <= X"0" ;
         elsif en = '1' then
            countTemp <= (countTemp + 1) mod 10 ;
         end if ;
      END process incre ;
END vecteur ; 

library genlib ;

architecture instance of decade is
begin
dec : mod_cpt generic map (modulo => 10)
              port map (clk => clk, clear => raz, cen => en,
                        cout => integer(count), rco => dix) ;
end instance ;

