-- decimal.vhd

package decimal is
   type chiffre is range 0 to 9 ;
   type nombre is array (integer range <>) of chiffre ;
   function "+"(a,b : chiffre) return chiffre ;
   component decade
      port (clk, en,raz : in bit ;
            count: out chiffre ;
            dix  : out bit) ;
   end component ;
   component mod_cpt is
   generic(modulo : integer := 16) ;
   port(clk, clear, cen : in bit ;
        cout : out integer range 0 to modulo-1 ;
        rco  : out bit ) ;
   end component mod_cpt ;
end decimal ;

package body decimal is
   function sum10 (a,b : integer) return integer ;
   function "+"(a,b : chiffre) return chiffre is
   begin
      return chiffre(sum10(integer(a),integer(b))) ;
   end "+" ;

   function sum10 (a,b : integer) return integer is
      variable tmp : integer range 0 to 18 ;
   begin
      tmp := a + b ;
      if tmp > 9 then
         tmp := tmp - 10 ;
      end if ;
      return tmp ;
   end sum10 ;
end decimal ;
